#include "stdafx.h"
#include "charbuffer.h"

CCharBuffer::CCharBuffer(size_t initialSize)
{
	m_size = initialSize;
	if (m_size > 0) {
		m_buffer = new char[m_size];
	} else {
		m_buffer = NULL;
	}
}

CCharBuffer::~CCharBuffer(void)
{
	if (m_buffer != NULL && m_size > 0) {
		delete [] m_buffer;
	}
}


bool CCharBuffer::checkSize(size_t suspectedSize) {
	if (suspectedSize > m_size) {
		if (m_buffer != NULL && m_size > 0) {
			delete [] m_buffer;
		}
		if (m_size > 0) {
			m_size <<= 1;
			while (m_size < suspectedSize) {
				m_size <<= 1;
			}
		} else {
			m_size = suspectedSize;
		}
		m_buffer = new char[m_size];
		return true;	// size was changed
	} else {
		return false;	// size wasn't changed
	}
}

void CCharBuffer::reset() {
	if (m_buffer != NULL && m_size > 0) {
		delete [] m_buffer;
	}
	m_buffer = NULL;
	m_size   = 0;
}
